<?php

/**
 * @file
 * Definition of SalsaEntity.
 */

/*
 * Entity class for the Salsa entity.
 */
class SalsaEntity extends Entity {

  /**
   * Can be used to pass additional fields to the save callback.
   *
   * @var array
   */
  public $additional = array();

  /**
   * Overrides Entity::buildContent().
   */
  public function buildContent($view_mode = 'full', $langcode = NULL) {
    $wrapper = entity_metadata_wrapper($this->entityType, $this);

    foreach ($wrapper as $key => $property) {
      $info = $property->info();
      $content[$key] = array(
        '#type' => 'item',
        '#title' => $info['label'],
        '#markup' => $property->value(),
      );
    }
    return entity_get_controller($this->entityType)->buildContent($this, $view_mode, $langcode, $content);
  }

  public function defaultUri() {
    return array(
      'path' => 'salsa/' . str_replace('salsa_', '', $this->entityType) . '/' . $this->{$this->idKey},
      'options' => array(),
    );
  }
}
